package bindingwrappermethods.view.backing;

import java.util.Map;

import oracle.adf.model.BindingContext;

import oracle.binding.BindingContainer;
import oracle.binding.OperationBinding;


public class FirstCalc
{
	protected static final Integer TEN = new Integer(10);
	protected static final Integer TWENTY = new Integer(20);

	public FirstCalc()
	{
	}

	public BindingContainer getBindings()
	{
		return BindingContext.getCurrent().getCurrentBindingsEntry();
	}

	public Integer doMyAdd(Integer pFirstOperand, Integer pSecondOperand)
	{
		BindingContainer vBindingContainer = getBindings();
		OperationBinding vOperationBinding =
			vBindingContainer.getOperationBinding("doMyAdd");
		Map vParamsMap = vOperationBinding.getParamsMap();
		vParamsMap.put("pFirstOperand", pFirstOperand);
		vParamsMap.put("pSecondOperand", pSecondOperand);
		Object vResult = vOperationBinding.execute();
		if (!vOperationBinding.getErrors().isEmpty())
		{
			// TODO review how to handle OperationBinding execute failure
			throw new RuntimeException("executing operation binding "
				+ vOperationBinding.getName() + " failed");
		}
		return (Integer)vResult;
	}

	protected Integer getSecondOperand()
	{
		return (Integer)(getBindings().get("doMyAdd_pSecondOperand"));
	}

	public String doMyAddToTenAction()
	{
		try
		{
			Integer vResult = doMyAdd(TEN, getSecondOperand());
			// Passing the second operand as null also seems to work, I am not sure why.
			//Integer vResult = doMyAdd(TEN, null);
		}
		catch(RuntimeException ex)
		{
			System.out.println("FirstCalc.doMyAddToTenAction()"
				+ " : ex = " + ex);
		}
		return null;
	}

	public String doMyAddToTwentyAction()
	{
		try
		{
			Integer vResult = doMyAdd(TWENTY, getSecondOperand());
		}
		catch(RuntimeException ex)
		{
			System.out.println("FirstCalc.doMyAddToTwentyAction()"
				+ " : ex = " + ex);
		}
		return null;
	}
}
